/**
 * 创建表格
 * @param t
 * @return
 */
function createTable(t){
	var sqlStr = "";
	var n = 0;
	var tbname = $("tablename");
	var comment = $("comment").value.trim();
	var fnames = document.getElementsByName("fieldname");
	var ftypes = document.getElementsByName("fieldtype");
	var fnulls = document.getElementsByName("fieldnull");
	var fkeys = document.getElementsByName("fieldkey");
	var fvalues = document.getElementsByName("fieldvalue");
	var ftexts = document.getElementsByName("fieldtext");
	
	if(""==tbname.value.trim()){
		alert("表名不能为空！");
		tbname.focus();
		return;
	}
	
	if(t==0){//SQL Server
		var comments = "";
		var bigcolumn = 0;
		sqlStr += "CREATE TABLE ["+tbname.value.trim()+"](";
		
		for(var i=0;i<fnames.length;i++){
			if(""!=fnames[i].value.trim()){
				var ftype = ftypes[i].value;
				if(ftype.indexOf("(自动编号)")>0){
					ftype = "[int] IDENTITY(1,1)";
				}
				
				//字段属性
				sqlStr += "\r\n";
				sqlStr += " ["+fnames[i].value.trim()+"] "+ftype;
				sqlStr += " "+(fnulls[i].checked?"":"NOT NULL");
				if(ftype.indexOf("IDENTITY")==-1){
					sqlStr += " default "+(""==fvalues[i].value.trim()?"NULL":("'"+fvalues[i].value.trim()+"'"));
				}
				sqlStr += ",";
				
				//创建字段备注
				if(""!=ftexts[i].value.trim()){
					comments += "\r\n\r\n";
					comments += "EXEC sys.sp_addextendedproperty @name=N'MS_Description',@value=N'"+ftexts[i].value.trim()+"',";
					comments += "@level0type=N'SCHEMA',@level0name=N'dbo',@level1type=N'TABLE',@level1name=N'"+tbname.value.trim()+"',";
					comments += "@level2type=N'COLUMN',@level2name=N'"+fnames[i].value.trim()+"';";
				}
				
				//判断是否有大字段
				if("text"==ftype || "ntext"==ftype || "image"==ftype || ftype.indexOf("(max)")>0 || "xml"==ftype){
					bigcolumn = 1;
				}				
				n++;
			}
		}		
		
		//创建主键
		var keyStr = "";
		if("0"!=fkeys[0].checked && ""!=fnames[0].value.trim()){
			keyStr = "\r\n CONSTRAINT [PK_"+tbname.value.trim()+"] PRIMARY KEY CLUSTERED(";
			keyStr += "["+fnames[0].value.trim()+"] ASC)WITH (PAD_INDEX=OFF,IGNORE_DUP_KEY=OFF) ON [PRIMARY]";
		}				
		if(keyStr=="" && ","==sqlStr.substring(sqlStr.length-1)){
			sqlStr = sqlStr.substring(0, sqlStr.length-1);
		}		
		sqlStr += keyStr+"\r\n)";
		sqlStr += (""!=keyStr?"ON [PRIMARY]":"");
		sqlStr += (""!=keyStr&&bigcolumn==1?" TEXTIMAGE_ON [PRIMARY]":"")+";";
		
		//创建表备注
		if(""!=comment){
			comments += "\r\n\r\n";
			comments += "EXEC sys.sp_addextendedproperty @name=N'MS_Description',@value=N'"+comment+"',";
			comments += "@level0type=N'SCHEMA',@level0name=N'dbo', @level1type=N'TABLE',@level1name=N'"+tbname.value.trim()+"'";
		}
		
		sqlStr += comments;
	}
	else if(t==1){//MySQL
		sqlStr = "--DROP TABLE IF EXISTS `"+tbname.value.trim()+"`;\r\n";
		sqlStr += "CREATE TABLE `"+tbname.value.trim()+"`(";
		
		for(var i=0;i<fnames.length;i++){
			if(""!=fnames[i].value.trim()){
				var auto_increment = "";
				var ftype = ftypes[i].value;
				if(ftype.indexOf("自动编号")>0){
					ftype = "int(11)";
					auto_increment = " auto_increment";
				}
				
				//字段属性
				sqlStr += "\r\n";
				sqlStr += " `"+fnames[i].value.trim()+"` "+ftype;
				sqlStr += " "+(fnulls[i].checked?"":"NOT NULL");
				if(""==auto_increment){
					sqlStr += " default "+(""==fvalues[i].value.trim()?"''":("'"+fvalues[i].value.trim()+"'"));
				}
				if(""!=ftexts[i].value.trim()){
					sqlStr += " COMMENT '"+ftexts[i].value.trim()+"'";
				}

				sqlStr += auto_increment + ",";
				n++;
			}			
		}
		
		//创建主键
		var keyStr = "";
		if("0"!=fkeys[0].checked && ""!=fnames[0].value.trim()){
			keyStr = "\r\n PRIMARY KEY (`"+fnames[0].value.trim()+"`)";
		}		
		if(keyStr=="" && ","==sqlStr.substring(sqlStr.length-1)){
			sqlStr = sqlStr.substring(0, sqlStr.length-1);
		}
		
		sqlStr += keyStr+"\r\n) ENGINE=MyISAM DEFAULT CHARSET=utf8 COMMENT='"+comment+"';";
	}
	
	if(n==0){
		alert("列名不能为空！");
		return;
	}
	
	$("sqltext").value = sqlStr;
	autoHeight($("sqltext"));
}

var row=-1;
/**
 * 增加列
 * @return
 */
function addField(t){
	var fieldTable = $("fieldTable");
	
	if(row==-1){
		row = fieldTable.rows.length -1;
	}
	
	var newRow=fieldTable.insertRow(row);
	newRow.setAttribute("id","nf"+row);
	
	for(var i=0;i<fieldTable.rows[0].cells.length;i++){
		var newCell = newRow.insertCell(i);		
		if(i==0){
			newCell.innerHTML = '<a href="javascript:removeField(\'nf'+row+'\');" title="删除列"><img src="images/dtree/del.gif" alt="删除列" /></a>';
		}
		else if(t==1 && i==6){
			newCell.innerHTML = '&nbsp;';
		}
		else{
			if(i==3){
				newCell.setAttribute("align","center");
			}
			newCell.innerHTML = fieldTable.rows[2].cells[i].innerHTML;
		}		
	}

	var texts = newRow.getElementsByTagName("input");
	for(var i=0;i<texts.length;i++){
		if(t==1){
			texts[i].removeAttribute("disabled");
		}
		texts[i].value = "";
	}
	
	var selects = newRow.getElementsByTagName("select");
	for(var i=0;i<selects.length;i++){
		if(t==1){
			selects[i].removeAttribute("disabled");
		}
		selects[i].options[0].selected="selected";
	}
	
	row++;
}

/**
 * 移除新增的列
 * @param id
 * @return
 */
function removeField(id){
	var fieldTable = $("fieldTable");
	for(var i=0;i<fieldTable.rows.length;i++){
		if(id==fieldTable.rows[i].id){
			fieldTable.deleteRow(i);
			row--;
		}
	}
}

/**
 * 删除列
 * @param t
 * @param tname
 * @param fname
 * @return
 */
function deleteField(t,tname,fname){
	if(t==0){
		var dropStr = "ALTER TABLE ["+tname+"] DROP COLUMN ["+fname+"];";
		
		if($("sqltext").value.indexOf(dropStr)==-1){
			$("sqltext").value += dropStr + "\r\n";
		}
	}
	else if(t==1){
		var dropStr = "ALTER TABLE `"+tname+"` DROP COLUMN `"+fname+"`;";
		
		if($("sqltext").value.indexOf(dropStr)==-1){
			$("sqltext").value += dropStr + "\r\n";
		}
	}
}

/**
 * 修改列
 * @param id
 * @return
 */
function modifyField(id,obj){
	var allow = obj.checked;
	var texts = $(id).getElementsByTagName("input");
	for(var i=0;i<texts.length;i++){
		if(texts[i].name!="fieldflag"){
			if(allow){
				texts[i].removeAttribute("disabled");
			}
			else{
				texts[i].setAttribute("disabled","disabled");
			}
		}
	}
	
	var selects = $(id).getElementsByTagName("select");
	for(var i=0;i<selects.length;i++){
		if(allow){
			selects[i].removeAttribute("disabled");
		}
		else{
			selects[i].setAttribute("disabled","disabled");
		}
	}
}

/**
 * 修改表格
 * @param t
 * @return
 */
function modifyTable(t){
	var sqlStr = "";
	var n = 0;
	var tbname = $("tablename");
	var comment = $("comment").value.trim();
	var ofnames = document.getElementsByName("ofieldname");
	var fnames = document.getElementsByName("fieldname");
	var ftypes = document.getElementsByName("fieldtype");
	var fnulls = document.getElementsByName("fieldnull");
	var fkeys = document.getElementsByName("fieldkey");
	var fvalues = document.getElementsByName("fieldvalue");
	var ftexts = document.getElementsByName("fieldtext");
	var fieldflag = document.getElementsByName("fieldflag");
	
	if(""==tbname.value.trim()){
		alert("表名不能为空！");
		tbname.focus();
		return;
	}
	
	if(t==0){//SQL Server
		for(var i=0;i<ofnames.length;i++){
			if(fieldflag[i].checked){
				if(""!=fvalues[i].value.trim()){
					sqlStr += "ALTER TABLE ["+tbname.value.trim()+"] ADD  DEFAULT ('"+fvalues[i].value.trim()+"') FOR ["+fnames[i].value.trim()+"];\r\n";
				}
				sqlStr += "ALTER TABLE ["+tbname.value.trim()+"] ALTER COLUMN ["+fnames[i].value.trim()+"] "+ftypes[i].value.trim();
				sqlStr += " "+(fnulls[i].checked?"":"NOT NULL");
				sqlStr += ";\n\r";
			}
		}
	}
	else if(t==1){//MySQL
		for(var i=0;i<ofnames.length;i++){//修改
			if(fieldflag[i].checked){
				sqlStr += "ALTER TABLE `"+tbname.value.trim()+"` CHANGE COLUMN `"+ofnames[i].value.trim()+"` `"+fnames[i].value.trim()+"` "+ftypes[i].value.trim();
				sqlStr += " "+(fnulls[i].checked?"NULL":"NOT NULL");
				sqlStr += " DEFAULT "+(""==fvalues[i].value.trim()?"NULL":"'"+fvalues[i].value.trim()+"'");
				sqlStr += " COMMENT '"+ftexts[i].value.trim()+"';\n\r";
			}
		}
		if(fnames.length>ofnames.length){//新增
			for(var i=ofnames.length;i<fnames.length;i++){
				sqlStr += "ALTER TABLE `"+tbname.value.trim()+"` ADD COLUMN `"+fnames[i].value.trim()+"` "+ftypes[i].value.trim();
				sqlStr += " "+(fnulls[i].checked?"NULL":"NOT NULL");
				sqlStr += " DEFAULT "+(""==fvalues[i].value.trim()?"NULL":"'"+fvalues[i].value.trim()+"'");
				sqlStr += " COMMENT '"+ftexts[i].value.trim()+"';\n\r";
			}
		}
		if(tbname.value.trim()!=$("oldtname").value.trim()){//表重命名
			sqlStr += "ALTER TABLE `"+$("oldtname").value.trim()+"` COMMENT='"+comment+"', RENAME TO `"+tbname.value.trim()+"`;\n\r";
		}
		else if(comment!=$("oldcomment").value.trim()){//修改备注
			sqlStr += "ALTER TABLE `"+tbname.value.trim()+"` COMMENT='"+comment+"';\n\r";
		}
	}
	
	$("sqltext").value = sqlStr;
	autoHeight($("sqltext"));
}